var util = require('util')
  , Constants = require('jsr-constants')
  , StoreError = require('jsr-error')
  , CommandArgLength = StoreError.CommandArgLength
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the PING command.
 */
function Ping() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Ping, AbstractCommand);

/**
 *  Validate the PING command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  if(args.length > 1) {
    throw new CommandArgLength(cmd);
  }
}

/**
 *  Respond to the PING command.
 */
function execute(req, res) {
  if(req.args.length) return res.send(null, req.args[0]);
  res.send(null, Constants.PONG);
}

Ping.prototype.validate = validate;
Ping.prototype.execute = execute;

module.exports = new Ping(Constants.MAP.ping);
