var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the HINCRBYFLOAT command.
 */
function HashIncrementByFloat() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(HashIncrementByFloat, AbstractCommand);

/**
 *  Respond to the HINCRYBYFLOAT command.
 */
function execute(req, res) {
  // store returns a number but we need to send
  // a bulk string reply
  var reply = req.exec.proxy(req, res);
  res.send(null, '' + reply);
}

HashIncrementByFloat.prototype.execute = execute;

module.exports = new HashIncrementByFloat(Constants.MAP.hincrbyfloat);
