var util = require('util')
  , StoreError = require('jsr-error')
  , CommandArgLength = StoreError.CommandArgLength
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the HMSET command.
 */
function HashMultiSet() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(HashMultiSet, AbstractCommand);

/**
 *  Validate the HMSET command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  if((args.length - 1) % 2 !== 0) {
    throw new CommandArgLength(cmd);
  }
}

HashMultiSet.prototype.validate = validate;

module.exports = new HashMultiSet(Constants.MAP.hmset);
