var util = require('util')
  , Constants = require('jsr-constants')
  , Scan = require('../key/scan')
  , Scanner = require('../../../scanner');

/**
 *  Handler for the HSCAN command.
 */
function HashScan() {
  Scan.apply(this, arguments);
  this.offset = 2;
}

util.inherits(HashScan, Scan);

/**
 *  Respond to the HSCAN command.
 */
function execute(req, res) {
  //console.dir(req.args);
  var hmap = req.db.getKey(req.args[0], req);
  if(hmap === undefined) {
    return res.send(null, [0, []]);
  }
  //console.dir(hmap.getKeys())
  var scanner = new Scanner(
    hmap.getKeys(),
    req.info.cursor,
    req.info.pattern,
    req.info.count,
    hmap.data);

  scanner.scan(req, res);
}

HashScan.prototype.execute = execute;

module.exports = new HashScan(Constants.MAP.hscan);
