var util = require('util')
  , Constants = require('jsr-constants')
  , dump = require('jsr-persistence').dump
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the DUMP command.
 */
function Dump() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Dump, AbstractCommand);

/**
 *  Respond to the DUMP command.
 */
function execute(req, res) {
  var value = req.db.getKey(req.args[0], req);
  if(value === undefined) return res.send(null, null);
  var buf = dump(
    {value: value}, value.rtype || Constants.TYPE_NAMES.STRING, null);
  res.send(null, buf);
}

Dump.prototype.execute = execute;

module.exports = new Dump(Constants.MAP.dump);
