var util = require('util')
  , StoreError = require('jsr-error')
  , DatabaseIndex = StoreError.DatabaseIndex
  , SourceDestination = StoreError.SourceDestination
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the MOVE command.
 */
function Move() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Move, AbstractCommand);

/**
 *  Validate the MOVE command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  var index = parseInt(args[1]);
  if(isNaN(index) || index < 0 || index >= info.conf.databases) {
    throw DatabaseIndex;
  }

  // attempt to move within the current db
  if(index === info.conn.db) {
    throw SourceDestination;
  }

  args[1] = index;
}

Move.prototype.validate = validate;

module.exports = new Move(Constants.MAP.move);
