var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand
  , StoreError = require('jsr-error')
  , SourceDestination = StoreError.SourceDestination
  , NoSuchKey = StoreError.NoSuchKey;

/**
 *  Handler for the RENAME command.
 */
function Rename() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Rename, AbstractCommand);

/**
 *  Validate the RENAME command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);

  var source = '' + args[0]
    , destination = '' + args[1];

  if(!info.db.getKey(args[0], info)) {
    throw NoSuchKey;
  }else if(source === destination) {
    throw SourceDestination;
  }
  args[0] = source;
  args[1] = destination;
}

Rename.prototype.validate = validate;

Rename.definition = Constants.MAP.rename;

module.exports = Rename;
