var util = require('util')
  , Constants = require('jsr-constants')
  , Scan = require('../key/scan')
  , Scanner = require('../../../scanner');

/**
 *  Handler for the SSCAN command.
 */
function SetScan() {
  Scan.apply(this, arguments);
  this.offset = 2;
}

util.inherits(SetScan, Scan);

/**
 *  Respond to the SSCAN command.
 */
function execute(req, res) {
  var set = req.db.getKey(req.args[0], req);
  if(set === undefined) {
    return res.send(null, [0, []]);
  }
  //console.dir('scanning');
  //console.dir(set.data);
  var scanner = new Scanner(
    set.data, req.info.cursor, req.info.pattern, req.info.count);
  scanner.scan(req, res);
}

SetScan.prototype.execute = execute;

module.exports = new SetScan(Constants.MAP.sscan);
