var util = require('util')
  , StoreError = require('jsr-error')
  , IntegerRange = StoreError.IntegerRange
  , CommandArgLength = StoreError.CommandArgLength
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the BITCOUNT command.
 */
function BitCount() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(BitCount, AbstractCommand);

/**
 *  Validate the BITCOUNT command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  var start
    , end;

  if(args.length !== 1 && args.length !== 3) {
    throw new CommandArgLength(cmd);
  }

  if(args.length > 1) {
    start = parseInt('' + args[1]);
    if(isNaN(start)) throw IntegerRange;
    args[1] = start;
    end = parseInt('' + args[2]);
    if(isNaN(end)) throw IntegerRange;
    args[2] = end;
  }
}

BitCount.prototype.validate = validate;

module.exports = new BitCount(Constants.MAP.bitcount);
