var util = require('util')
  , StoreError = require('jsr-error')
  , CommandSyntax = StoreError.CommandSyntax
  , BitopNot = StoreError.BitopNot
  , Constants = require('jsr-constants')
  , BITOP = Constants.BITOP
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the BITOP command.
 */
function BitOperation() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(BitOperation, AbstractCommand);

/**
 *  Validate the BITOP command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  var op = ('' + args[0]).toLowerCase();
  if(op !== BITOP.AND && op !== BITOP.OR
    && op !== BITOP.XOR && op !== BITOP.NOT) {
    throw CommandSyntax;
  }
  if(op === BITOP.NOT && args.length !== 3) {
    throw BitopNot;
  }
  args[0] = op;
}

BitOperation.prototype.validate = validate;

module.exports = new BitOperation(Constants.MAP.bitop);
