var util = require('util')
  , StoreError = require('jsr-error')
  , IntegerRange = StoreError.IntegerRange
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the GETBIT command.
 */
function GetBit() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(GetBit, AbstractCommand);

/**
 *  Validate the GETBIT command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  var offset = parseInt('' + args[1]);
  if(isNaN(offset) || offset < 0 || offset > Constants.MAX_BIT_LEN) {
    throw IntegerRange;
  }
  args[1] = offset;
}

GetBit.prototype.validate = validate;

GetBit.definition = Constants.MAP.getbit;

module.exports = GetBit;
