var util = require('util')
  , StoreError = require('jsr-error')
  , InvalidBit = StoreError.InvalidBit
  , Constants = require('jsr-constants')
  , AbstractCommand = require('./getbit');

/**
 *  Handler for the SETBIT command.
 */
function SetBit() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(SetBit, AbstractCommand);

/**
 *  Validate the SETBIT command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  var value = parseInt('' + args[2]);
  if(value !== 0 && value !== 1) throw InvalidBit;
  args[2] = value;
}

SetBit.prototype.validate = validate;

module.exports = new SetBit(Constants.MAP.setbit);
