var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the ZINCRBY command.
 */
function SortedSetIncrBy() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(SortedSetIncrBy, AbstractCommand);

/**
 *  Respond to the ZINCRBY command.
 */
function execute(req, res) {
  // store returns a number but we need to send
  // a bulk string reply
  var reply = req.exec.proxy(req, res);
  res.send(null, '' + reply);
}

SortedSetIncrBy.prototype.execute = execute;

module.exports = new SortedSetIncrBy(Constants.MAP.zincrby);
