var util = require('util')
  , StoreError = require('jsr-error')
  , CommandSyntax = StoreError.CommandSyntax
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the ZRANGE command.
 */
function SortedSetRange() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(SortedSetRange, AbstractCommand);

/**
 *  Validate the ZRANGE command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  var withscores;
  if(args.length > 3) {
    withscores = ('' + args[3]).toLowerCase();
    if(withscores !== Constants.ZSET.WITHSCORES) {
      throw CommandSyntax;
    }
    args[3] = withscores;
  }
}

SortedSetRange.prototype.validate = validate;

SortedSetRange.definition = Constants.MAP.zrange;

module.exports = SortedSetRange;
