var util = require('util')
  , Constants = require('jsr-constants')
  , Scan = require('../key/scan')
  , Scanner = require('../../../scanner');

/**
 *  Handler for the ZSCAN command.
 */
function SortedSetScan() {
  Scan.apply(this, arguments);
  this.offset = 2;
}

util.inherits(SortedSetScan, Scan);

/**
 *  Respond to the ZSCAN command.
 */
function execute(req, res) {
  var zset = req.db.getKey(req.args[0], req);

  if(zset === undefined) {
    return res.send(null, [0, []]);
  }

  var scanner = new Scanner(
    zset.getKeys(),
    req.info.cursor,
    req.info.pattern,
    req.info.count,
    zset.data,
    true);

  scanner.scan(req, res);
}

SortedSetScan.prototype.execute = execute;

module.exports = new SortedSetScan(Constants.MAP.zscan);
