var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').DatabaseCommand;

/**
 *  Handler for the ZSCORE command.
 */
function SortedSetScore() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(SortedSetScore, AbstractCommand);

/**
 *  Respond to the ZSCORE command.
 */
function execute(req, res) {
  // store returns a number but we need to send
  // a bulk string reply
  var reply = req.exec.proxy(req, res);
  res.send(null, reply ? '' + reply : reply);
}

SortedSetScore.prototype.execute = execute;

module.exports = new SortedSetScore(Constants.MAP.zscore);
