var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the PSUBSCRIBE command.
 */
function PatternSubscribe() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(PatternSubscribe, AbstractCommand);

/**
 *  Respond to the PSUBSCRIBE command.
 */
function execute(req, res) {
  this.state.pubsub.psubscribe(req.conn, req.args);
}

PatternSubscribe.prototype.execute = execute;

module.exports = new PatternSubscribe(Constants.MAP.psubscribe);
