var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the PUBLISH command.
 */
function Publish() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Publish, AbstractCommand);

/**
 *  Respond to the PUBLISH command.
 */
function execute(req, res) {
  // must coerce channel to string
  var len = this.state.pubsub.publish(
    req.conn, '' + req.args[0], req.args[1]);
  res.send(null, len);
}

Publish.prototype.execute = execute;

module.exports = new Publish(Constants.MAP.publish);
