var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the PUNSUBSCRIBE command.
 */
function PatternUnsubscribe() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(PatternUnsubscribe, AbstractCommand);

/**
 *  Respond to the PUNSUBSCRIBE command.
 */
function execute(req, res) {
  this.state.pubsub.punsubscribe(req.conn, req.args);
}

PatternUnsubscribe.prototype.execute = execute;

module.exports = new PatternUnsubscribe(Constants.MAP.punsubscribe);
