var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the UNSUBSCRIBE command.
 */
function Unsubscribe() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Unsubscribe, AbstractCommand);

/**
 *  Respond to the UNSUBSCRIBE command.
 */
function execute(req, res) {
  this.state.pubsub.unsubscribe(req.conn, req.args);
}

Unsubscribe.prototype.execute = execute;

module.exports = new Unsubscribe(Constants.MAP.unsubscribe);
