var util = require('util')
  , Constants = require('jsr-constants')
  , ScriptManager = require('jsr-script').ScriptManager
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the EVALSHA command.
 */
function EvalSha() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(EvalSha, AbstractCommand);

/**
 *  Respond to the EVALSHA command.
 */
function execute(req, res) {
  ScriptManager.evalsha(req, res, '' + req.args[0], req.args.slice(1));
}

EvalSha.prototype.execute = execute;

module.exports = new EvalSha(Constants.MAP.evalsha);
