var util = require('util')
  , Constants = require('jsr-constants')
  , ScriptManager = require('jsr-script').ScriptManager
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the SCRIPT command.
 */
function Script() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Script, AbstractCommand);

/**
 *  Respond to the EXISTS subcommand.
 */
function exists(req, res) {
  ScriptManager.exists(req, res, req.args);
}

/**
 *  Respond to the FLUSH subcommand.
 */
function flush(req, res) {
  ScriptManager.flush(req, res);
}

/**
 *  Respond to the KILL subcommand.
 */
function kill(req, res) {
  // lua-time-limit
  ScriptManager.kill(req, res);
}

/**
 *  Respond to the LOAD subcommand.
 */
function load(req, res) {
  ScriptManager.load(req, res, '' + req.args[0]);
}

/**
 *  Respond to the SCRIPT command.
 */
function execute(req, res) {
  this.delegate(req, res);
}

Script.prototype.execute = execute;

// subcommands
Script.prototype.exists = exists;
Script.prototype.flush = flush;
Script.prototype.kill = kill;
Script.prototype.load = load;

module.exports = new Script(Constants.MAP.script);
