var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the FLUSHDB command.
 */
function FlushDatabase() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(FlushDatabase, AbstractCommand);

/**
 *  Respond to the FLUSHDB command.
 */
function execute(req, res) {
  // TODO: ensure a conflict is triggered on all watched keys
  req.db.flushdb();
  res.send(null, Constants.OK);
}

FlushDatabase.prototype.execute = execute;

module.exports = new FlushDatabase(Constants.MAP.flushdb);
