var util = require('util')
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the LASTSAVE command.
 */
function LastSave() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(LastSave, AbstractCommand);

/**
 *  Respond to the LASTSAVE command.
 */
function execute(req, res) {
  // stored in milliseconds but this command returns seconds
  res.send(null, Math.round(this.state.lastsave / 1000));
}

LastSave.prototype.execute = execute;

module.exports = new LastSave(Constants.MAP.lastsave);
