var util = require('util')
  , Constants = require('jsr-constants')
  , Persistence = require('jsr-persistence')()
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the SAVE command.
 *
 *  Synchronous save to disk, samve caveats apply as the redis
 *  implementation - this blocks the event loop, clients will not
 *  be served.
 */
function Save() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Save, AbstractCommand);

/**
 *  Respond to the SAVE command.
 */
function execute(req, res) {
  Persistence.save(this.state.store, this.state.conf);
  res.send(null, Constants.OK);
}

Save.prototype.execute = execute;

module.exports = new Save(Constants.MAP.save);
