var util = require('util')
  , systime = require('jsr-util').time
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the TIME command.
 */
function Time() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Time, AbstractCommand);

/**
 *  Respond to the TIME command.
 */
function execute(req, res) {
  var t = systime();
  res.send(null, [t.s, t.m]);
}

Time.prototype.execute = execute;

module.exports = new Time(Constants.MAP.time);
