var util = require('util')
  , StoreError = require('jsr-error')
  , ExecWithoutMulti = StoreError.ExecWithoutMulti
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the EXEC command.
 */
function Exec() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Exec, AbstractCommand);

/**
 *  Respond to the EXEC command.
 */
function execute(req, res) {
  // execute the transaction
  req.conn.transaction.exec(this, req, res);
}

/**
 *  Validate the EXEC command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  if(!info.conn.transaction) {
    throw ExecWithoutMulti;
  }
}

Exec.prototype.validate = validate;
Exec.prototype.execute = execute;

module.exports = new Exec(Constants.MAP.exec);
