var util = require('util')
  , StoreError = require('jsr-error')
  , NestedMulti = StoreError.NestedMulti
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command
  , Transaction = require('../../transaction');

/**
 *  Handler for the MULTI command.
 */
function Multi() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Multi, AbstractCommand);

/**
 *  Respond to the MULTI command.
 */
function execute(req, res) {
  // setup the transaction
  req.conn.transaction = new Transaction();
  res.send(null, Constants.OK);
}

/**
 *  Validate the MULTI command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  if(info.conn.transaction) {
    throw NestedMulti;
  }
}

Multi.prototype.validate = validate;
Multi.prototype.execute = execute;

module.exports = new Multi(Constants.MAP.multi);
