var util = require('util')
  , StoreError = require('jsr-error')
  , UnwatchWithoutMulti = StoreError.UnwatchWithoutMulti
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the UNWATCH command.
 */
function Unwatch() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Unwatch, AbstractCommand);

/**
 *  Respond to the UNWATCH command.
 */
function execute(req, res) {
  req.conn.unwatch(req.db);
  res.send(null, Constants.OK);
}

Unwatch.prototype.execute = execute;

module.exports = new Unwatch(Constants.MAP.unwatch);
