var util = require('util')
  , StoreError = require('jsr-error')
  , WatchInsideMulti = StoreError.WatchInsideMulti
  , Constants = require('jsr-constants')
  , AbstractCommand = require('jsr-exec').Command;

/**
 *  Handler for the WATCH command.
 */
function Watch() {
  AbstractCommand.apply(this, arguments);
}

util.inherits(Watch, AbstractCommand);

/**
 *  Respond to the WATCH command.
 */
function execute(req, res) {
  req.conn.watch(req.args, req.db);
  res.send(null, Constants.OK);
}

/**
 *  Validate the WATCH command.
 */
function validate(cmd, args, info) {
  AbstractCommand.prototype.validate.apply(this, arguments);
  if(info.conn.transaction) {
    throw WatchInsideMulti;
  }
}

Watch.prototype.validate = validate;
Watch.prototype.execute = execute;

module.exports = new Watch(Constants.MAP.watch);
